Index: c/src/lib/libcpu/powerpc/mpc55xx/edma/edma.c
===================================================================
--- c/src/lib/libcpu/powerpc/mpc55xx/edma/edma.c	(revision 243596d65e9fc5541fc731c8ad7fc3fdc0bcaf9b)
+++ c/src/lib/libcpu/powerpc/mpc55xx/edma/edma.c	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -23,7 +23,8 @@
 #include <mpc55xx/mpc55xx.h>
 
+#include <string.h>
+
 #include <bsp/irq.h>
-
-#include <string.h>
+#include <bsp/utility.h>
 
 #define RTEMS_STATUS_CHECKS_USE_PRINTK
@@ -31,109 +32,100 @@
 #include <rtems/status-checks.h>
 
-#define MPC55XX_EDMA_CHANNEL_NUMBER 64
-#define MPC55XX_EDMA_INVALID_CHANNEL UINT8_MAX
-#define MPC55XX_EDMA_IS_CHANNEL_INVALID( i) ((i) < 0 || (i) >= MPC55XX_EDMA_CHANNEL_NUMBER)
-
-#define MPC55XX_EDMA_IRQ_PRIORITY MPC55XX_INTC_MIN_PRIORITY
-
-typedef struct {
-	uint8_t channel;
-	rtems_id transfer_update;
-	uint32_t *error_status;
-} mpc55xx_edma_channel_entry;
-
-static mpc55xx_edma_channel_entry mpc55xx_edma_channel_table [MPC55XX_EDMA_CHANNEL_NUMBER];
-
-static uint32_t mpc55xx_edma_channel_occupation_low = 0;
-
-static uint32_t mpc55xx_edma_channel_occupation_high = 0;
-
-static rtems_id mpc55xx_edma_channel_occupation_mutex = RTEMS_ID_NONE;
-
-static uint8_t mpc55xx_edma_irq_error_low_channel = 0;
-
-static uint8_t mpc55xx_edma_irq_error_high_channel = 32;
-
-static void mpc55xx_edma_irq_handler( rtems_vector_number vector, void *data)
-{
-	rtems_status_code sc = RTEMS_SUCCESSFUL;
-	mpc55xx_edma_channel_entry *e = (mpc55xx_edma_channel_entry *) data;
+#define MPC55XX_EDMA_CHANNEL_NUMBER 64U
+
+#define MPC55XX_EDMA_INVALID_CHANNEL MPC55XX_EDMA_CHANNEL_NUMBER
+
+#define MPC55XX_EDMA_IS_CHANNEL_INVALID( i) ((unsigned) (i) >= MPC55XX_EDMA_CHANNEL_NUMBER)
+
+#define MPC55XX_EDMA_IS_CHANNEL_VALID( i) ((unsigned) (i) < MPC55XX_EDMA_CHANNEL_NUMBER)
+
+#define MPC55XX_EDMA_IRQ_PRIORITY MPC55XX_INTC_DEFAULT_PRIORITY
+
+#define MPC55XX_EDMA_CHANNEL_FLAG( channel) ((uint64_t) 1 << (channel))
+
+static uint64_t mpc55xx_edma_channel_occupation = 0;
+
+static rtems_chain_control mpc55xx_edma_channel_chain;
+
+static void mpc55xx_edma_interrupt_handler( rtems_vector_number vector, void *arg)
+{
+	mpc55xx_edma_channel_entry *e = (mpc55xx_edma_channel_entry *) arg;
+
 #ifdef DEBUG
 	uint32_t citer = EDMA.TCD [e->channel].CITERE_LINK ? EDMA.TCD [e->channel].CITER & EDMA_TCD_BITER_LINKED_MASK : EDMA.TCD [e->channel].CITER;
-	RTEMS_DEBUG_PRINT( "Channel %i (CITER = %i)\n", e->channel, citer);
+	RTEMS_DEBUG_PRINT( "channel %i (CITER = %i)\n", e->channel, citer);
 #endif /* DEBUG */
-	EDMA.CIRQR.R = e->channel;
-	sc = rtems_semaphore_release( e->transfer_update);
-	RTEMS_SYSLOG_WARNING_SC( sc, "Transfer update semaphore release");
-}
-
-static void mpc55xx_edma_irq_update_error_table( uint8_t *link_table, uint8_t *error_table, int channel)
-{
-	int i = 0;
-	error_table [channel] = 1;
-	for (i = 0; i < MPC55XX_EDMA_CHANNEL_NUMBER; ++i) {
-		if (channel == link_table [i] && error_table [i] == 0) {
-			mpc55xx_edma_irq_update_error_table( link_table, error_table, i);
-		}
-	}
-}
-
-static void mpc55xx_edma_irq_error_handler( rtems_vector_number vector, void *data)
-{
-	rtems_status_code sc = RTEMS_SUCCESSFUL;
-	uint8_t channel_start = *((uint8_t *) data);
-	uint8_t channel_end = (uint8_t) (channel_start + 32);
-	int i = 0;
-	uint32_t mask = 0x1;
-	uint32_t error_register = 0;
-	uint8_t channel_link_table [MPC55XX_EDMA_CHANNEL_NUMBER];
-	uint8_t channel_error_table [MPC55XX_EDMA_CHANNEL_NUMBER];
-
-	/* Error register */
-	if (channel_start < 32) {
-		error_register = EDMA.ERL.R;
-	} else if (channel_start < 64) {
-		error_register = EDMA.ERH.R;
-	}
-	RTEMS_DEBUG_PRINT( "Error register %s: 0x%08x\n", channel_start < 32 ? "low" : "high", error_register);
-
-	/* Fill channel link table */
-	for (i = 0; i < MPC55XX_EDMA_CHANNEL_NUMBER; ++i) {
-		if (EDMA.TCD [i].BITERE_LINK && EDMA.TCD [i].CITER != EDMA.TCD [i].BITER) {
-			channel_link_table [i] = (uint8_t) EDMA_TCD_BITER_LINK( i);
-		} else if (EDMA.TCD [i].MAJORE_LINK && EDMA.TCD [i].CITER == EDMA.TCD [i].BITER) {
-			channel_link_table [i] = EDMA.TCD [i].MAJORLINKCH;
-		} else {
-			channel_link_table [i] = MPC55XX_EDMA_INVALID_CHANNEL;
-		}
-		channel_error_table [i] = 0;
-	}
-
-	/* Search for channels with errors */
-	for (i = channel_start; i < channel_end; ++i) {
-		if ((error_register & mask) != 0) {
-			mpc55xx_edma_irq_update_error_table( channel_link_table, channel_error_table, i);
-		}
-		mask <<= 1;
-	}
+
+	/* Clear interrupt */
+	EDMA.CIRQR.R = (uint8_t) e->channel;
+
+	/* Notify user */
+	e->done( e, 0);
+}
+
+static void mpc55xx_edma_interrupt_error_handler( rtems_vector_number vector, void *arg)
+{
+	rtems_chain_control *chain = &mpc55xx_edma_channel_chain;
+	rtems_chain_node *node = chain->first;
+	unsigned i = 0;
+	uint64_t error_status = EDMA.ESR.R;
+	uint64_t error_channels = ((uint64_t) EDMA.ERH.R << 32) | EDMA.ERL.R;
+	uint64_t error_channels_update = 0;
+
+	RTEMS_DEBUG_PRINT( "error channels: %08x %08x\n", (unsigned) (error_channels >> 32), (unsigned) error_channels);
+
+	/* Mark all channels that are linked to a channel with errors */
+	do {
+		error_channels_update = 0;
+
+		for (i = 0; i < MPC55XX_EDMA_CHANNEL_NUMBER; ++i) {
+			uint64_t channel_flags = 0;
+			unsigned minor_link = i;
+			unsigned major_link = i;
+
+			/* Check if we have linked channels */
+			if (EDMA.TCD [i].BMF.B.BITERE_LINK) {
+				minor_link = EDMA_TCD_BITER_LINK( i);
+			}
+			if (EDMA.TCD [i].BMF.B.MAJORE_LINK) {
+				major_link = EDMA.TCD [i].BMF.B.MAJORLINKCH;
+			}
+
+			/* Set flags related to this channel */
+			channel_flags = MPC55XX_EDMA_CHANNEL_FLAG( i) | MPC55XX_EDMA_CHANNEL_FLAG( minor_link) | MPC55XX_EDMA_CHANNEL_FLAG( major_link);
+
+			/* Any errors in these channels? */
+			if (IS_ANY_FLAG_SET( error_channels, channel_flags)) {
+				/* Get new error channels */
+				uint64_t update = (error_channels & channel_flags) ^ channel_flags;
+
+				/* Update error channels */
+				error_channels = SET_FLAGS( error_channels, channel_flags);
+
+				/* Contribute to the update of this round */
+				error_channels_update = SET_FLAGS( error_channels_update, update);
+			}
+		}
+	} while (error_channels_update != 0);
+
+	RTEMS_DEBUG_PRINT( "error channels (all): %08x %08x\n", (unsigned) (error_channels >> 32), (unsigned) error_channels);
 
 	/* Process the channels related to errors */
-	error_register = EDMA.ESR.R;
-	for (i = 0; i < MPC55XX_EDMA_CHANNEL_NUMBER; ++i) {
-		if (channel_error_table [i]) {
-			mpc55xx_edma_channel_entry *e = &mpc55xx_edma_channel_table [i];
-			if (e->error_status != NULL) {
-				*e->error_status = error_register;
-			}
-			sc = mpc55xx_edma_enable_hardware_requests( i, false);
-			RTEMS_SYSLOG_ERROR_SC( sc, "Disable hardware requests");
-			sc = rtems_semaphore_release( e->transfer_update);
-			RTEMS_SYSLOG_WARNING_SC( sc, "Transfer update semaphore release");
-		}
+	while (!rtems_chain_is_tail( chain, node)) {
+		mpc55xx_edma_channel_entry *e = (mpc55xx_edma_channel_entry *) node;
+
+		if (IS_FLAG_SET( error_channels, MPC55XX_EDMA_CHANNEL_FLAG( e->channel))) {
+			mpc55xx_edma_enable_hardware_requests( e->channel, false);
+
+			/* Notify user */
+			e->done( e, error_status);
+		}
+
+		node = node->next;
 	}
 
 	/* Clear the error interrupt requests */
 	for (i = 0; i < MPC55XX_EDMA_CHANNEL_NUMBER; ++i) {
-		if (channel_error_table [i]) {
+		if (IS_FLAG_SET( error_channels, MPC55XX_EDMA_CHANNEL_FLAG( i))) {
 			EDMA.CER.R = (uint8_t) i;
 		}
@@ -141,28 +133,28 @@
 }
 
-rtems_status_code mpc55xx_edma_enable_hardware_requests( int channel, bool enable)
-{
-	if (MPC55XX_EDMA_IS_CHANNEL_INVALID( channel)) {
-		return RTEMS_INVALID_NUMBER;
-	}
-	if (enable) {
-		EDMA.SERQR.R = (uint8_t) channel;
+void mpc55xx_edma_enable_hardware_requests( unsigned channel, bool enable)
+{
+	if (MPC55XX_EDMA_IS_CHANNEL_VALID( channel)) {
+		if (enable) {
+			EDMA.SERQR.R = (uint8_t) channel;
+		} else {
+			EDMA.CERQR.R = (uint8_t) channel;
+		}
 	} else {
-		EDMA.CERQR.R = (uint8_t) channel;
-	}
-	return RTEMS_SUCCESSFUL;
-}
-
-rtems_status_code mpc55xx_edma_enable_error_interrupts( int channel, bool enable)
-{
-	if (MPC55XX_EDMA_IS_CHANNEL_INVALID( channel)) {
-		return RTEMS_INVALID_NUMBER;
-	}
-	if (enable) {
-		EDMA.SEEIR.R = channel;
+		RTEMS_SYSLOG_ERROR( "invalid channel number\n");
+	}
+}
+
+void mpc55xx_edma_enable_error_interrupts( unsigned channel, bool enable)
+{
+	if (MPC55XX_EDMA_IS_CHANNEL_VALID( channel)) {
+		if (enable) {
+			EDMA.SEEIR.R = (uint8_t) channel;
+		} else {
+			EDMA.CEEIR.R = (uint8_t) channel;
+		}
 	} else {
-		EDMA.CEEIR.R = channel;
-	}
-	return RTEMS_SUCCESSFUL;
+		RTEMS_SYSLOG_ERROR( "invalid channel number\n");
+	}
 }
 
@@ -170,15 +162,7 @@
 {
 	rtems_status_code sc = RTEMS_SUCCESSFUL;
-	int i = 0;
-
-	/* Channel occupation mutex */
-	sc = rtems_semaphore_create (
-		rtems_build_name ( 'D', 'M', 'A', 'O'),
-		1,
-		RTEMS_SIMPLE_BINARY_SEMAPHORE | RTEMS_INHERIT_PRIORITY | RTEMS_PRIORITY,
-		RTEMS_NO_PRIORITY,
-		&mpc55xx_edma_channel_occupation_mutex
-	);
-	RTEMS_CHECK_SC( sc, "Create channel occupation mutex");
+
+	/* Initialize channel chain */
+	rtems_chain_initialize_empty( &mpc55xx_edma_channel_chain);
 
 	/* Arbitration mode: round robin */
@@ -189,91 +173,100 @@
 	memset( &EDMA.TCD [0], 0, sizeof( EDMA.TCD));
 
-	/* Channel table */
-	for (i = 0; i < MPC55XX_EDMA_CHANNEL_NUMBER; ++i) {
-		mpc55xx_edma_channel_table [i].channel = i;
-		mpc55xx_edma_channel_table [i].transfer_update = RTEMS_ID_NONE;
-		mpc55xx_edma_channel_table [i].error_status = NULL;
-	}
-
-	/* Error interrupt handler */
+	/* Error interrupt handlers */
 	sc = mpc55xx_interrupt_handler_install(
 		MPC55XX_IRQ_EDMA_ERROR_LOW,
-		MPC55XX_EDMA_IRQ_PRIORITY,
 		"eDMA Error (Low)",
 		RTEMS_INTERRUPT_UNIQUE,
-		mpc55xx_edma_irq_error_handler,
-		&mpc55xx_edma_irq_error_low_channel
-	);
-	RTEMS_CHECK_SC( sc, "Install low error interrupt handler");
+		MPC55XX_EDMA_IRQ_PRIORITY,
+		mpc55xx_edma_interrupt_error_handler,
+		NULL
+	);
+	RTEMS_CHECK_SC( sc, "install low error interrupt handler");
 	sc = mpc55xx_interrupt_handler_install(
 		MPC55XX_IRQ_EDMA_ERROR_HIGH,
-		MPC55XX_EDMA_IRQ_PRIORITY,
 		"eDMA Error (High)",
 		RTEMS_INTERRUPT_UNIQUE,
-		mpc55xx_edma_irq_error_handler,
-		&mpc55xx_edma_irq_error_high_channel
-	);
-	RTEMS_CHECK_SC( sc, "Install high error interrupt handler");
+		MPC55XX_EDMA_IRQ_PRIORITY,
+		mpc55xx_edma_interrupt_error_handler,
+		NULL
+	);
+	RTEMS_CHECK_SC( sc, "install high error interrupt handler");
 
 	return RTEMS_SUCCESSFUL;
 }
 
-rtems_status_code mpc55xx_edma_obtain_channel( int channel, uint32_t *error_status, rtems_id transfer_update)
+rtems_status_code mpc55xx_edma_obtain_channel( mpc55xx_edma_channel_entry *e)
 {
 	rtems_status_code sc = RTEMS_SUCCESSFUL;
-	int channel_occupied = 1;
-
-	if (MPC55XX_EDMA_IS_CHANNEL_INVALID( channel)) {
+	rtems_interrupt_level level;
+	uint64_t channel_occupation = 0;
+
+	if (MPC55XX_EDMA_IS_CHANNEL_INVALID( e->channel)) {
 		return RTEMS_INVALID_NUMBER;
 	}
 
-	/* Check occupation */
-	sc = rtems_semaphore_obtain( mpc55xx_edma_channel_occupation_mutex, RTEMS_WAIT, 0);
-	RTEMS_CHECK_SC( sc, "Obtain channel occupation mutex");
-	if (channel < 32) {
-		channel_occupied = mpc55xx_edma_channel_occupation_low & (0x1 << channel);
-		if (!channel_occupied) {
-			mpc55xx_edma_channel_occupation_low |= 0x1 << channel;
-		}
-	} else if (channel < 64) {
-		channel_occupied = mpc55xx_edma_channel_occupation_high & (0x1 << (channel - 32));
-		if (!channel_occupied) {
-			mpc55xx_edma_channel_occupation_high |= 0x1 << (channel - 32);
-		}
-	}
-	if (channel_occupied) {
-		sc = rtems_semaphore_release( mpc55xx_edma_channel_occupation_mutex);
-		RTEMS_SYSLOG_WARNING_SC( sc, "Release occupation mutex");
+	/* Test and set channel occupation flag */
+	rtems_interrupt_disable( level);
+	channel_occupation = mpc55xx_edma_channel_occupation;
+	if (IS_FLAG_CLEARED( channel_occupation, MPC55XX_EDMA_CHANNEL_FLAG( e->channel))) {
+		mpc55xx_edma_channel_occupation = SET_FLAG( channel_occupation, MPC55XX_EDMA_CHANNEL_FLAG( e->channel));
+	}
+	rtems_interrupt_enable( level);
+
+	/* Check channel occupation flag */
+	if (IS_FLAG_SET( channel_occupation, MPC55XX_EDMA_CHANNEL_FLAG( e->channel))) {
 		return RTEMS_RESOURCE_IN_USE;
-	} else {
-		sc = rtems_semaphore_release( mpc55xx_edma_channel_occupation_mutex);
-		RTEMS_CHECK_SC( sc, "Release channel occupation mutex");
-	}
-
-	/* Channel data */
-	mpc55xx_edma_channel_table [channel].transfer_update = transfer_update;
-	mpc55xx_edma_channel_table [channel].error_status = error_status;
+	}
 
 	/* Interrupt handler */
 	sc = mpc55xx_interrupt_handler_install(
-		MPC55XX_IRQ_EDMA_GET_REQUEST( channel),
-		MPC55XX_EDMA_IRQ_PRIORITY,
+		MPC55XX_IRQ_EDMA_GET_REQUEST( e->channel),
 		"eDMA Channel",
 		RTEMS_INTERRUPT_SHARED,
-		mpc55xx_edma_irq_handler,
-		&mpc55xx_edma_channel_table [channel]
-	);
-	RTEMS_CHECK_SC( sc, "Install channel interrupt handler");
+		MPC55XX_EDMA_IRQ_PRIORITY,
+		mpc55xx_edma_interrupt_handler,
+		e
+	);
+	RTEMS_CHECK_SC( sc, "install channel interrupt handler");
 
 	/* Enable error interrupts */
-	sc = mpc55xx_edma_enable_error_interrupts( channel, true);
-	RTEMS_CHECK_SC( sc, "Enable error interrupts");
+	mpc55xx_edma_enable_error_interrupts( e->channel, true);
+
+	/* Prepend channel entry to channel list */
+	rtems_chain_prepend( &mpc55xx_edma_channel_chain, &e->node);
 
 	return RTEMS_SUCCESSFUL;
 }
 
-rtems_status_code mpc55xx_edma_release_channel( int channel)
-{
-	// TODO
-	return RTEMS_NOT_IMPLEMENTED;
-}
+rtems_status_code mpc55xx_edma_release_channel( mpc55xx_edma_channel_entry *e)
+{
+	rtems_status_code sc = RTEMS_SUCCESSFUL;
+	rtems_interrupt_level level;
+
+	/* Clear channel occupation flag */
+	rtems_interrupt_disable( level);
+	mpc55xx_edma_channel_occupation = CLEAR_FLAG( mpc55xx_edma_channel_occupation, MPC55XX_EDMA_CHANNEL_FLAG( e->channel));
+	rtems_interrupt_enable( level);
+
+	/* Disable hardware requests */
+	mpc55xx_edma_enable_hardware_requests( e->channel, false);
+
+	/* Disable error interrupts */
+	mpc55xx_edma_enable_error_interrupts( e->channel, false);
+
+	/* Extract channel entry from channel chain */
+	rtems_chain_extract( &e->node);
+
+	/* Remove interrupt handler */
+	sc = rtems_interrupt_handler_remove(
+		MPC55XX_IRQ_EDMA_GET_REQUEST( e->channel),
+		mpc55xx_edma_interrupt_handler,
+		e
+	);
+	RTEMS_CHECK_SC( sc, "remove channel interrupt handler");
+
+	/* Notify user */
+	e->done( e, 0);
+
+	return RTEMS_SUCCESSFUL;
+}
Index: c/src/lib/libcpu/powerpc/mpc55xx/emios/emios.c
===================================================================
--- c/src/lib/libcpu/powerpc/mpc55xx/emios/emios.c	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
+++ c/src/lib/libcpu/powerpc/mpc55xx/emios/emios.c	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -0,0 +1,109 @@
+/**
+ * @file
+ *
+ * @ingroup mpc55xx
+ *
+ * @brief Enhanced Modular Input Output Subsystem (eMIOS).
+ */
+
+/*
+ * Copyright (c) 2009
+ * embedded brains GmbH
+ * Obere Lagerstr. 30
+ * D-82178 Puchheim
+ * Germany
+ * <rtems@embedded-brains.de>
+ *
+ * The license and distribution terms for this file may be
+ * found in the file LICENSE in this distribution or at
+ * http://www.rtems.com/license/LICENSE.
+ */
+
+#include <mpc55xx/regs.h>
+#include <mpc55xx/emios.h>
+#include <mpc55xx/mpc55xx.h>
+
+#include <bsp/irq.h>
+#include <bsp/utility.h>
+
+#define RTEMS_STATUS_CHECKS_USE_PRINTK
+
+#include <rtems/status-checks.h>
+
+/**
+ * @brief Initialize the eMIOS module.
+ *
+ * The module is enabled.  It is configured to use the internal clock.  The
+ * global prescaler value is set to @a prescaler.  If the value is greater than
+ * the maximum the maxium value will be used instead.  A prescaler value of
+ * zero disables the clock.
+ *
+ * @note No protection against concurrent execution.
+ */
+void mpc55xx_emios_initialize( unsigned prescaler)
+{
+  union EMIOS_MCR_tag mcr = MPC55XX_ZERO_FLAGS;
+
+  /* Enable module */
+  mcr.B.MDIS = 0;
+
+  /* Disable debug mode */
+  mcr.B.FRZ = 1;
+
+  /* Enable global time base */
+  mcr.B.GTBE = 1;
+
+  /* Disable global prescaler (= disable clock) */
+  mcr.B.GPREN = 0;
+
+  /* Set MCR */
+  EMIOS.MCR.R = mcr.R;
+
+  /* Set OUDR */
+  EMIOS.OUDR.R = 0;
+
+  /* Set global prescaler value */
+  mpc55xx_emios_set_global_prescaler( prescaler);
+}
+
+/**
+ * @brief Returns the global prescaler value of the eMIOS module.
+ */
+unsigned mpc55xx_emios_global_prescaler( void)
+{
+  union EMIOS_MCR_tag mcr = EMIOS.MCR;
+
+  if (mcr.B.GPREN != 0) {
+    return mcr.B.GPRE + 1;
+  } else {
+    return 0;
+  }
+}
+
+/**
+ * @brief Sets the global prescaler value of the eMIOS module.
+ *
+ * The global prescaler value is set to @a prescaler.  If the value is greater
+ * than the maximum the maxium value will be used instead.  A prescaler value
+ * of zero disables the clock.
+ *
+ * @note No protection against concurrent execution.
+ */
+void mpc55xx_emios_set_global_prescaler( unsigned prescaler)
+{
+  union EMIOS_MCR_tag mcr = EMIOS.MCR;
+
+  /* Enable or disable the global prescaler */
+  mcr.B.GPREN = prescaler > 0 ? 1 : 0;
+
+  /* Set global prescaler value */
+  if (prescaler > 256) {
+    prescaler = 256;
+  } else if (prescaler < 1) {
+    prescaler = 1;
+  }
+  mcr.B.GPRE = prescaler - 1;
+
+  /* Set MCR */
+  EMIOS.MCR.R = mcr.R;
+}
Index: c/src/lib/libcpu/powerpc/mpc55xx/esci/esci.c
===================================================================
--- c/src/lib/libcpu/powerpc/mpc55xx/esci/esci.c	(revision 243596d65e9fc5541fc731c8ad7fc3fdc0bcaf9b)
+++ c/src/lib/libcpu/powerpc/mpc55xx/esci/esci.c	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -42,5 +42,5 @@
 #undef CR2
 
-#define MPC55XX_ESCI_IRQ_PRIORITY MPC55XX_INTC_MIN_PRIORITY
+#define MPC55XX_ESCI_IRQ_PRIORITY MPC55XX_INTC_DEFAULT_PRIORITY
 
 #define MPC55XX_ESCI_IS_MINOR_INVALD(minor) ((minor) < 0 || (minor) >= MPC55XX_ESCI_NUMBER)
@@ -74,10 +74,5 @@
  */
 static const struct termios mpc55xx_esci_termios_default = {
-	0,
-	0,
-	CS8 | CREAD | CLOCAL | B115200,
-	0,
-	0,
-	{ 0 }
+	.c_cflag = CS8 | CREAD | CLOCAL | B115200
 };
 
@@ -120,74 +115,109 @@
 	volatile union ESCI_DR_tag *data = &e->regs->DR;
 	union ESCI_SR_tag sr = MPC55XX_ZERO_FLAGS;
-
-	while (status->B.TDRE == 0) {
-		/* Wait */
-	}
-
-	/* Clear flag */
+	rtems_interrupt_level level;
+
+	/* Set clear flag */
 	sr.B.TDRE = 1;
-	status->R = sr.R;
-
-	/* Write */
-	data->B.D = c;
-}
-
-/** @} */
-
-/**
- * @name Termios Support
- * @{
- */
-
-/**
- * @brief Opens port @a minor.
- *
- * @return Status code.
- */
-static int mpc55xx_esci_termios_first_open( int major, int minor, void *arg)
-{
-	mpc55xx_esci_driver_entry *e = &mpc55xx_esci_driver_table [minor];
+
+	while (true) {
+		rtems_interrupt_disable( level);
+		if (status->B.TDRE != 0) {
+			/* Clear flag */
+			status->R = sr.R;
+
+			/* Write */
+			data->B.D = c;
+
+			/* Done */
+			rtems_interrupt_enable( level);
+			break;
+		}
+		rtems_interrupt_enable( level);
+
+		while (status->B.TDRE == 0) {
+			/* Wait */
+		}
+	}
+}
+
+static inline void mpc55xx_esci_interrupts_enable( mpc55xx_esci_driver_entry *e)
+{
 	union ESCI_CR1_tag cr1 = MPC55XX_ZERO_FLAGS;
-	struct rtems_termios_tty *tty = ((rtems_libio_open_close_args_t *) arg)->iop->data1;
-
-	/* Check minor number */
-	if (MPC55XX_ESCI_IS_MINOR_INVALD( minor)) {
-		return RTEMS_INVALID_NUMBER;
-	}
-
-	/* Connect TTY */
-	e->tty = tty;	
-
-	/* Enable interrupts */
-	if (MPC55XX_ESCI_USE_INTERRUPTS( e)) {
-		cr1.R = e->regs->CR1.R;
-		cr1.B.RIE = 1;
-		cr1.B.TIE = 1;
-		e->regs->CR1.R = cr1.R;
-	}
-
-	return RTEMS_SUCCESSFUL;
-}
-
-/**
- * @brief Closes port @a minor.
- *
- * @return Status code.
- */
-static int mpc55xx_esci_termios_last_close( int major, int minor, void* arg)
-{
-	mpc55xx_esci_driver_entry *e = &mpc55xx_esci_driver_table [minor];
+	rtems_interrupt_level level;
+
+	rtems_interrupt_disable( level);
+	cr1.R = e->regs->CR1.R;
+	cr1.B.RIE = 1;
+	cr1.B.TIE = 1;
+	e->regs->CR1.R = cr1.R;
+	rtems_interrupt_enable( level);
+}
+
+static inline void mpc55xx_esci_interrupts_disable( mpc55xx_esci_driver_entry *e)
+{
 	union ESCI_CR1_tag cr1 = MPC55XX_ZERO_FLAGS;
-
-	/* Check minor number */
-	if (MPC55XX_ESCI_IS_MINOR_INVALD( minor)) {
-		return RTEMS_INVALID_NUMBER;
-	}
-
-	/* Disable interrupts */
+	rtems_interrupt_level level;
+
+	rtems_interrupt_disable( level);
 	cr1.R = e->regs->CR1.R;
 	cr1.B.RIE = 0;
 	cr1.B.TIE = 0;
 	e->regs->CR1.R = cr1.R;
+	rtems_interrupt_enable( level);
+}
+
+/** @} */
+
+/**
+ * @name Termios Support
+ * @{
+ */
+
+/**
+ * @brief Opens port @a minor.
+ *
+ * @return Status code.
+ */
+static int mpc55xx_esci_termios_first_open( int major, int minor, void *arg)
+{
+	int rv = 0;
+	mpc55xx_esci_driver_entry *e = &mpc55xx_esci_driver_table [minor];
+	struct rtems_termios_tty *tty = ((rtems_libio_open_close_args_t *) arg)->iop->data1;
+
+	/* Check minor number */
+	if (MPC55XX_ESCI_IS_MINOR_INVALD( minor)) {
+		return RTEMS_INVALID_NUMBER;
+	}
+
+	/* Connect TTY */
+	e->tty = tty;	
+
+	/* Enable interrupts */
+	if (MPC55XX_ESCI_USE_INTERRUPTS( e)) {
+		mpc55xx_esci_interrupts_enable( e);
+	}
+
+	rv = rtems_termios_set_initial_baud( e->tty, 115200);
+	RTEMS_CHECK_RV_SC( rv, "Set initial baud");
+
+	return RTEMS_SUCCESSFUL;
+}
+
+/**
+ * @brief Closes port @a minor.
+ *
+ * @return Status code.
+ */
+static int mpc55xx_esci_termios_last_close( int major, int minor, void* arg)
+{
+	mpc55xx_esci_driver_entry *e = &mpc55xx_esci_driver_table [minor];
+
+	/* Check minor number */
+	if (MPC55XX_ESCI_IS_MINOR_INVALD( minor)) {
+		return RTEMS_INVALID_NUMBER;
+	}
+
+	/* Disable interrupts */
+	mpc55xx_esci_interrupts_disable( e);
 
 	/* Disconnect TTY */
@@ -205,11 +235,18 @@
 {
 	mpc55xx_esci_driver_entry *e = &mpc55xx_esci_driver_table [minor];
-	
-	/* Check minor number */
-	if (MPC55XX_ESCI_IS_MINOR_INVALD( minor)) {
+	volatile union ESCI_SR_tag *status = &e->regs->SR;
+	volatile union ESCI_DR_tag *data = &e->regs->DR;
+	union ESCI_SR_tag sr = MPC55XX_ZERO_FLAGS;
+
+	if (status->B.RDRF == 0) {
 		return -1;
 	}
 
-	return (int) mpc55xx_esci_read_char( e);
+	/* Clear flag */
+	sr.B.RDRF = 1;
+	status->R = sr.R;
+
+	/* Read */
+	return data->B.D;
 }
 
@@ -232,7 +269,4 @@
 	for (i = 0; i < n; ++i) {
 		mpc55xx_esci_write_char( e, out [i]);
-		if (out [i] == '\n') {
-			mpc55xx_esci_write_char( e, '\r');
-		}
 	}
 
@@ -480,7 +514,7 @@
 				sc = mpc55xx_interrupt_handler_install(
 					e->irq_number,
-					MPC55XX_ESCI_IRQ_PRIORITY,
 					"eSCI",
 					RTEMS_INTERRUPT_UNIQUE,
+					MPC55XX_ESCI_IRQ_PRIORITY,
 					mpc55xx_esci_termios_interrupt_handler,
 					e
@@ -512,11 +546,5 @@
 			sc =  rtems_termios_open( major, minor, arg, &mpc55xx_esci_termios_callbacks_polled);
 		}
-		if (sc != RTEMS_SUCCESSFUL) {
-			return sc;
-		}
-		rv = rtems_termios_set_initial_baud( e->tty, 115200);
-		if (rv < 0) {
-			return RTEMS_IO_ERROR;
-		}
+		RTEMS_CHECK_SC( sc, "Open");
 	}
 
@@ -624,8 +652,11 @@
 {
 	mpc55xx_esci_driver_entry *e = &mpc55xx_esci_driver_table [mpc55xx_esci_output_char_minor];
+
+	mpc55xx_esci_interrupts_disable( e);
 	mpc55xx_esci_write_char( e, c);
 	if (c == '\n') {
 		mpc55xx_esci_write_char( e, '\r');
 	}
+	mpc55xx_esci_interrupts_enable( e);
 }
 
@@ -637,13 +668,15 @@
 static void mpc55xx_esci_output_char_init( char c)
 {
-	int console_found = 0;
+	bool console_found = false;
 	int i = 0;
+
 	for (i = 0; i < MPC55XX_ESCI_NUMBER; ++i) {
 		if (mpc55xx_esci_driver_table [i].console) {
-			console_found = 1;
+			console_found = true;
 			mpc55xx_esci_output_char_minor = i;
 			break;
 		}
 	}
+
 	if (console_found) {
 		BSP_output_char = mpc55xx_esci_output_char;
Index: c/src/lib/libcpu/powerpc/mpc55xx/include/dspi.h
===================================================================
--- c/src/lib/libcpu/powerpc/mpc55xx/include/dspi.h	(revision 243596d65e9fc5541fc731c8ad7fc3fdc0bcaf9b)
+++ c/src/lib/libcpu/powerpc/mpc55xx/include/dspi.h	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -29,4 +29,6 @@
 
 #include <rtems/libi2c.h>
+
+#include <mpc55xx/edma.h>
 
 #ifdef __cplusplus
@@ -65,5 +67,5 @@
 	 * @brief Selects SPI master or slave mode.
 	 */
-	int master;
+	bool master;
 
 	/**
@@ -73,43 +75,23 @@
 
 	/**
-	 * @brief eDMA channel for transmission.
+	 * @brief eDMA entry for transmission.
 	 *
-	 * The channel is fixed to particular DSPI.
+	 * The channel is fixed to a particular DSPI.
 	 */
-	int edma_channel_transmit;
+	mpc55xx_edma_channel_entry edma_transmit;
 
 	/**
-	 * @brief eDMA channel to generate the push data.
+	 * @brief eDMA entry for push data generation.
 	 *
-	 * You can choose any available channel.
+	 * You can choose every available channel.
 	 */
-	int edma_channel_push;
+	mpc55xx_edma_channel_entry edma_push;
 
 	/**
-	 * @brief eDMA channel for receiving.
+	 * @brief eDMA entry for receiving.
 	 *
-	 * The channel is fixed to particular DSPI.
+	 * The channel is fixed to a particular DSPI.
 	 */
-	int edma_channel_receive;
-
-	/**
-	 * @brief Semaphore ID for a transmit update.
-	 */
-	rtems_id edma_channel_transmit_update;
-
-	/**
-	 * @brief Semaphore ID for a receive update.
-	 */
-	rtems_id edma_channel_receive_update;
-
-	/**
-	 * @brief Transmit error status.
-	 */
-	uint32_t edma_channel_transmit_error;
-
-	/**
-	 * @brief Receive error status.
-	 */
-	uint32_t edma_channel_receive_error;
+	mpc55xx_edma_channel_entry edma_receive;
 
 	/**
@@ -117,4 +99,9 @@
 	 */
 	uint32_t idle_char;
+
+	/**
+	 * @brief Current baud.
+	 */
+	uint32_t baud;
 } mpc55xx_dspi_bus_entry;
 
Index: c/src/lib/libcpu/powerpc/mpc55xx/include/edma.h
===================================================================
--- c/src/lib/libcpu/powerpc/mpc55xx/include/edma.h	(revision 243596d65e9fc5541fc731c8ad7fc3fdc0bcaf9b)
+++ c/src/lib/libcpu/powerpc/mpc55xx/include/edma.h	(revision d374492cc69fa8bd041852d868ae379b79c59ba4)
@@ -23,6 +23,8 @@
 
 #include <stdbool.h>
+#include <stdint.h>
 
 #include <rtems.h>
+#include <rtems/chain.h>
 
 #ifdef __cplusplus
@@ -30,69 +32,20 @@
 #endif /* __cplusplus */
 
-#define MPC55XX_EDMA_TCD_DEFAULT { \
-	.SADDR = 0, \
-	.SMOD = 0, \
-	.SSIZE = 0x2, \
-	.SOFF = 4, \
-	.DADDR = 0, \
-	.DMOD = 0, \
-	.DSIZE = 0x2, \
-	.DOFF = 4, \
-	.NBYTES = 0, \
-	.SLAST = 0, \
-	.CITER = 1, \
-	.BITER = 1, \
-	.MAJORLINKCH = 0, \
-	.CITERE_LINK = 0, \
-	.BITERE_LINK = 0, \
-	.MAJORE_LINK = 0, \
-	.E_SG = 0, \
-	.DLAST_SGA = 0, \
-	.D_REQ = 0, \
-	.BWC = 0, \
-	.INT_HALF = 0, \
-	.INT_MAJ = 0, \
-	.DONE = 0, \
-	.ACTIVE = 0, \
-	.START = 0, \
-}
-
-#define MPC55XX_EDMA_TCD_ALT_DEFAULT { \
-	.SADDR = 0, \
-	.SMOD = 0, \
-	.SSIZE = 2, \
-	.DMOD = 0, \
-	.DSIZE = 2, \
-	.SOFF = 4, \
-	.NBYTES = 0, \
-	.SLAST = 0, \
-	.DADDR = 0, \
-	.CITERE_LINK = 0, \
-	.CITERLINKCH = 0, \
-	.CITER = 0, \
-	.DOFF = 4, \
-	.DLAST_SGA = 0, \
-	.BITERE_LINK = 0, \
-	.BITERLINKCH = 0, \
-	.BITER = 0, \
-	.BWC = 0, \
-	.MAJORLINKCH = 0, \
-	.DONE = 0, \
-	.ACTIVE = 0, \
-	.MAJORE_LINK = 0, \
-	.E_SG = 0, \
-	.D_REQ = 0, \
-	.INT_HALF = 0, \
-	.INT_MAJ = 0, \
-	.START = 0, \
-}
+typedef struct mpc55xx_edma_channel_entry {
+	rtems_chain_node node;
+	unsigned channel;
+	void (*done)( struct mpc55xx_edma_channel_entry *, uint32_t);
+	rtems_id id;
+} mpc55xx_edma_channel_entry;
 
 rtems_status_code mpc55xx_edma_init();
 
-rtems_status_code mpc55xx_edma_obtain_channel( int channel, uint32_t *error_status, rtems_id transfer_update);
+rtems_status_code mpc55xx_edma_obtain_channel( mpc55xx_edma_channel_entry *e);
 
-rtems_status_code mpc55xx_edma_enable_hardware_requests( int channel, bool enable);
+rtems_status_code mpc55xx_edma_release_channel( mpc55xx_edma_channel_entry *e);
 
-rtems_status_code mpc55xx_edma_enable_error_interrupts( int channel, bool enable);
+void mpc55xx_edma_enable_hardware_requests( unsigned channel, bool enable);
+
+void mpc55xx_edma_enable_error_interrupts( unsigned channel, bool enable);
 
 #ifdef __cplusplus
